/*******************************************************************************
 * FoxSpecialMove_SprintDash generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxSpecialMove_SprintDash extends FoxSpecialMove
    native(SpecialMoves);

var private const float DecelerationTime;
var private transient float DecelerationTimeLeft;
var private transient bool bStopping;
var private bool bIsAccelerating;
var private bool bCancelIfStopped;
var private AkEvent StartEvent;
var private AkEvent StopEvent;
var private float AccelerationDelay;

simulated function StartSpecialMove()
{
    super.StartSpecialMove();
    DecelerationTimeLeft = DecelerationTime;
    bStopping = false;
    bIsAccelerating = false;
    // End:0x77
    if(AccelerationDelay > 0.0)
    {
        PawnOwner.SetTimer(AccelerationDelay, false, 'SpecialMoveEventTimer');
    }
    // End:0x81
    else
    {
        TimerEvent();
    }
    // End:0xC2
    if(FoxPawn_HardSuit(PawnOwner) != none)
    {
        FoxPawn_HardSuit(PawnOwner).ToggleSprintEffects(true);
    }
    // End:0x185
    if(PawnOwner.IsLocallyControlled() && PawnOwner.IsHumanControlled())
    {
        FoxPC(PawnOwner.Controller).MyFoxHud.DynamicUI.HUD.as_showHardSuitBurnText();
    }
    PawnOwner.PostAkEvent(StartEvent);
    //return;    
}

simulated function TimerEvent()
{
    bIsAccelerating = true;
    PawnOwner.bForceMaxAccel = true;
    //return;    
}

simulated function bool RequestEndSpecialMove(FoxTypes.ESpecialMove NextMove)
{
    // End:0xB2
    if(!bStopping)
    {
        bStopping = true;
        bIsAccelerating = false;
        // End:0x68
        if(FoxPawn_HardSuit(PawnOwner) != none)
        {
            FoxPawn_HardSuit(PawnOwner).ToggleSprintEffects(false);
        }
        PawnOwner.bForceMaxAccel = false;
        PawnOwner.PostAkEvent(StopEvent);
    }
    // End:0x175
    if(PawnOwner.IsLocallyControlled() && PawnOwner.IsHumanControlled())
    {
        FoxPC(PawnOwner.Controller).MyFoxHud.DynamicUI.HUD.as_hideHardSuitBurnText();
    }
    return VSize(PawnOwner.Velocity) < (PawnOwner.GroundSpeed * PawnOwner.WalkingPct);
    //return ReturnValue;    
}

defaultproperties
{
    DecelerationTime=0.50
    bCancelIfStopped=true
    StartEvent=AkEvent'A_Hardsuit.Play_Hrdsuit_Rush_Start001'
    StopEvent=AkEvent'A_Hardsuit.Stop_Hrdsuit_Rush_Start001'
    SpeedModifier=2.0
    bLockPawnRotation=true
}